import sys
import itertools
import subprocess
import re
import csv

if __name__ == "__main__":
    bloqqerbin = sys.argv[1]
    depqbfbin = sys.argv[2]
    cnf = sys.argv[3]
    options = []
    restartre = re.compile("^Restart \d+, bt (\d+)")
    maxrestart = None

    with open(sys.argv[4], 'w') as output:
        outcsv = csv.writer(output)

        with subprocess.Popen([bloqqerbin, "--help"], stdout=subprocess.PIPE, universal_newlines=True) as blqhelp:
            for l in blqhelp.stdout:
                if "enable" in l:
                    info = l.strip().split(" ")

                    assert(info[0].endswith("<v>"))
                    options.append(info[0].replace("<v>", "%s"))

        outcsv.writerow(options + ["Backtracks", "Result"])

        for c in itertools.product(*[[0, 1]] * len(options)):
            with subprocess.Popen([bloqqerbin, cnf] + [options[i] % c[i] for i in range(0, len(options))], stdout=subprocess.PIPE, universal_newlines=True) as blq:
                restarts = 0
                depqbfargs = [depqbfbin, "-v"]

                if maxrestart is not None:
                    depqbfargs += ["--max-btracks=%s" % maxrestart]

                with subprocess.Popen(depqbfargs, stdin=blq.stdout, stderr=subprocess.PIPE, stdout=subprocess.DEVNULL, universal_newlines=True) as depqbf:
                    for l in depqbf.stderr:
                        m = restartre.search(l)

                        if m is not None:
                            restarts = int(m.group(1))

                    outcsv.writerow(list(c) + [restarts, depqbf.wait()])

                    if (maxrestart is None) or (restarts < maxrestart):
                        maxrestart = restarts
