#ifndef CIRCUIT_H
#define CRICUIT_H

#include <gmodule.h>

#include <circuit.h>

void sorter(Circuit * circ, lit_t a, lit_t b, lit_t * low, lit_t * high);

GArray * merge_network(Circuit * circ, GArray * a, GArray * b);

GArray * sort_network(Circuit * circ, GArray * lits, size_t first, size_t last);

// TODO This should really be a k-Cardinality network
// TODO Think about k >= lits->len
// (see Fig 2. of https://link.springer.com/article/10.1007/s10601-010-9105-0)
/**
 * There is an unfortunate issue with the return value here:
 * the circuit API in QuAbs will does not allow to query for
 * the value of a literal after circuit evaluation, so the
 * caller needs to know the nature of the variable returned
 * by this function: the var is supposed to be 0 if at most
 * k of the inputs are 1, thus the negation of the return
 * variable is probably what the caller needs.
 **/
var_t card_network(Circuit * circ, GArray * lits, size_t k);

#endif
