#!/bin/bash

export PYTHONPATH=..

prefix=$(basename $0 .sh);

python3 generate_experiments.py qdimacs ../../g127/isolators/bee20170615 10 ../depqbf-version-6.03/depqbf -L -r 10 -t 300 --PG $@ > $prefix-depqbf-default-nobloqqer.log
python3 generate_experiments.py qdimacs ../../g127/isolators/bee20170615 10 ../depqbf-version-6.03/depqbf -L -r 10 -t 300 --PG --bloqqer ../bloqqer-037-8660cb9-151127/bloqqer $@ > $prefix-depqbf-default-bloqqer.log
python3 generate_experiments.py qdimacs ../../g127/isolators/bee20170615 10 ../depqbf-version-6.03/depqbf -L -r 10 -t 300 --PG -s="--traditional-qcdcl" $@ > $prefix-depqbf-traditional-qcdcl-nobloqqer.log
python3 generate_experiments.py qdimacs ../../g127/isolators/bee20170615 10 ../depqbf-version-6.03/depqbf -L -r 10 -t 300 --PG --bloqqer ../bloqqer-037-8660cb9-151127/bloqqer -s="--traditional-qcdcl" $@ > $prefix-depqbf-traditional-qcdcl-bloqqer.log
python3 generate_experiments.py qdimacs ../../g127/isolators/bee20170615 10 ../rareqs-1.1/rareqs -L -r 10 -t 300 --PG -s="-uubp" -s="-h3" $@ > $prefix-rareqs-nobloqqer.log
python3 generate_experiments.py qdimacs ../../g127/isolators/bee20170615 10 ../rareqs-1.1/rareqs -L -r 10 -t 300 --PG -s="-uubp" -s="-h3" --bloqqer ../bloqqer-037-8660cb9-151127/bloqqer $@ > $prefix-rareqs-bloqqer.log
python3 generate_experiments.py qdimacs ../../g127/isolators/bee20170615 10 ../caqe/target/release/caqe -L -r 10 -t 300 --PG $@ > $prefix-caqe-default-nobloqqer.log
python3 generate_experiments.py qdimacs ../../g127/isolators/bee20170615 10 ../caqe/target/release/caqe -L -r 10 -t 300 --PG --bloqqer ../bloqqer-037-8660cb9-151127/bloqqer $@ > $prefix-caqe-default-bloqqer.log
python3 generate_experiments.py qdimacs ../../g127/isolators/bee20170615 10 ../caqe/target/release/caqe -L -r 10 -t 300 --PG -s="--expansion-refinement" -s 0 $@ > $prefix-caqe-no-expansion-refinement-nobloqqer.log
python3 generate_experiments.py qdimacs ../../g127/isolators/bee20170615 10 ../caqe/target/release/caqe -L -r 10 -t 300 --PG -s="--expansion-refinement" -s 0 --bloqqer ../bloqqer-037-8660cb9-151127/bloqqer $@ > $prefix-caqe-no-expansion-refinement-bloqqer.log

join -t '&' $prefix-depqbf-default-nobloqqer.log $prefix-depqbf-default-bloqqer.log \
| join -t '&' - $prefix-depqbf-traditional-qcdcl-nobloqqer.log | join -t '&' - $prefix-depqbf-traditional-qcdcl-bloqqer.log \
| join -t '&' - $prefix-rareqs-nobloqqer.log | join -t '&' - $prefix-rareqs-bloqqer.log \
| sed 's/$/\\\\\n\\hline/' > $prefix-depqbf,rareqs.tex
join -t '&' $prefix-caqe-default-nobloqqer.log $prefix-caqe-default-bloqqer.log \
| join -t '&' - $prefix-caqe-no-expansion-refinement-nobloqqer.log | join -t '&' - $prefix-caqe-no-expansion-refinement-bloqqer.log \
| sed 's/$/\\\\\n\\hline/' > $prefix-caqe.tex
