#include "../circuits.h"

#include <gsl/gsl_combination.h>

int main(int argc, char ** argv)
{
  Circuit * circ = circuit_init();
  Scope * exists = circuit_init_scope(circ, QUANT_EXISTS);
  lit_t low, high;

  circuit_new_var(circ, exists, 1);
  circuit_new_var(circ, exists, 2);
  sorter(circ, 1, 2, &low, &high);

  circuit_set_value(circ, 1, 0);
  circuit_set_value(circ, 2, 0);
  circuit_evaluate(circ);
  assert(circuit_get_value(circ, low) == 0);
  assert(circuit_get_value(circ, high) == 0);

  circuit_set_value(circ, 1, 0);
  circuit_set_value(circ, 2, 1);
  circuit_evaluate(circ);
  assert(circuit_get_value(circ, low) == 0);
  assert(circuit_get_value(circ, high) == 1);

  circuit_set_value(circ, 1, 1);
  circuit_set_value(circ, 2, 0);
  circuit_evaluate(circ);
  assert(circuit_get_value(circ, low) == 0);
  assert(circuit_get_value(circ, high) == 1);

  circuit_set_value(circ, 1, 1);
  circuit_set_value(circ, 2, 1);
  circuit_evaluate(circ);
  assert(circuit_get_value(circ, low) == 1);
  assert(circuit_get_value(circ, high) == 1);

  return 0;
}
